package com.tzld.longarticle.recommend.server.repository.crawler;

import com.tzld.longarticle.recommend.server.repository.entity.crawler.Article;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Set;

@Repository
public interface ArticleRepository extends JpaRepository<Article, String> {

    List<Article> getByAccountNameAndItemIndexInAndTypeEquals(String accountName, List<Integer> indexList, String type);

    List<Article> getByTitleMd5InAndTypeEquals(List<String> titleList, String type);

    List<Article> getByTitleInAndTypeEquals(List<String> titleList, String type);

    List<Article> getByGhIdInAndAppMsgIdInAndItemIndexAndTypeEquals(Set<String> ghIds, Set<String> appMsgIds, Integer itemIndex, String type);

    List<Article> getByGhIdInAndUpdateTimeGreaterThanAndTypeEquals(Set<String> ghIds, Long updateTime, String type);

}