package com.tzld.longarticle.recommend.server;

import com.tzld.longarticle.recommend.server.repository.crawler.AccountAvgInfoRepository;
import com.tzld.longarticle.recommend.server.repository.crawler.ArticleDetailInfoRepository;
import com.tzld.longarticle.recommend.server.repository.crawler.ArticleRepository;
import com.tzld.longarticle.recommend.server.repository.mapper.crawler.CrawlerBaseMapper;
import com.tzld.longarticle.recommend.server.service.RecommendService;
import com.tzld.longarticle.recommend.server.service.recall.RecallService;
import org.springframework.boot.test.context.SpringBootTest;

import javax.annotation.Resource;

@SpringBootTest(classes = Application.class)
public class RecommendTest {

    @Resource
    private RecommendService recommendService;
    @Resource
    private RecallService recallService;
    @Resource
    private ArticleRepository articleRepository;
    @Resource
    private ArticleDetailInfoRepository articleDetailInfoRepository;
    @Resource
    private AccountAvgInfoRepository accountAvgInfoRepository;
    @Resource
    private CrawlerBaseMapper crawlerBaseMapper;

//    @Test
//    void recall() {
//        RecallParam param = new RecallParam();
//        param.setAccountId("20231213123536190184852");
//        param.setPlanId("20240718181730864154902");
//        RecallResult recallResult = recallService.recall(param);
//        System.out.println(JSONObject.toJSONString(recallResult));
//    }
//
//    @Test
//    void exportData() {
//        Set<String> ghIds = new HashSet<>(Arrays.asList("gh_adca24a8f429", "gh_e0eb490115f5", "gh_51e4ad40466d", "gh_95ed5ecf9363"));
//        List<Article> articleList = articleRepository.getByGhIdInAndUpdateTimeGreaterThanAndTypeEquals(ghIds, 1722441600L, "9");
//
//        Map<String, Map<Integer, List<Article>>> map = articleList.stream()
//                .collect(Collectors.groupingBy(Article::getTitle, Collectors.groupingBy(Article::getItemIndex)));
//        Set<String> snList = articleList.stream().map(Article::getWxSn).collect(Collectors.toSet());
//        List<ArticleDetailInfo> articleDetailInfoList = articleDetailInfoRepository.getAllByWxSnIn(new ArrayList<>(snList));
//        Map<String, List<ArticleDetailInfo>> articleDetailInfoMap = articleDetailInfoList.stream()
//                .collect(Collectors.groupingBy(ArticleDetailInfo::getWxSn));
//
//        List<AccountAvgInfo> accountAvgInfoList = accountAvgInfoRepository.getAllByGhIdInAndStatusEquals(ghIds, 1);
//        Map<String, Map<String, AccountAvgInfo>> accountAvgInfoIndexMap = accountAvgInfoList.stream().collect(
//                Collectors.groupingBy(AccountAvgInfo::getGhId, Collectors.toMap(AccountAvgInfo::getPosition, o -> o)));
//        JSONArray jsonArray = new JSONArray();
//        for (Article article : articleList) {
//            List<ArticleDetailInfo> articleDetailInfos = articleDetailInfoMap.get(article.getWxSn());
//            if (CollectionUtils.isEmpty(articleDetailInfos)) {
//                continue;
//            }
//            Date minDate = articleDetailInfos.stream().map(ArticleDetailInfo::getRecallDt).min(Date::compareTo).orElse(new Date());
//            int sumfirstLevel = 0;
//            int sumFission0 = 0;
//            int sumFission1 = 0;
//            int sumFission2 = 0;
//            for (ArticleDetailInfo articleDetailInfo : articleDetailInfos) {
//                if (articleDetailInfo.getRecallDt().equals(minDate)) {
//                    sumfirstLevel += Optional.ofNullable(articleDetailInfo.getFirstLevel()).orElse(0);
//                    sumFission0 += Optional.ofNullable(articleDetailInfo.getFission0()).orElse(0);
//                    sumFission1 += Optional.ofNullable(articleDetailInfo.getFission1()).orElse(0);
//                    sumFission2 += Optional.ofNullable(articleDetailInfo.getFission2()).orElse(0);
//                }
//            }
//            Map<String, AccountAvgInfo> accountAvgInfoMap = accountAvgInfoIndexMap.get(article.getGhId());
//            AccountAvgInfo avgInfo = accountAvgInfoMap.get(article.getItemIndex().toString());
//            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
//            String date = sdf.format(new Date(article.getUpdateTime() * 1000));
//            JSONObject obj = new JSONObject();
//            obj.put("ghId", article.getGhId());
//            obj.put("accountName", article.getAccountName());
//            obj.put("title", article.getTitle());
//            obj.put("index", article.getItemIndex());
//            obj.put("viewCount", article.getShowViewCount());
//            obj.put("time", date);
//            if (Objects.nonNull(avgInfo)) {
//                obj.put("fans", avgInfo.getFans());
//                obj.put("avgViewCount", avgInfo.getReadAvg());
//                obj.put("viewCountRate", (article.getShowViewCount() * 1.0) / avgInfo.getReadAvg());
//            }
//            obj.put("firstLevel", sumfirstLevel);
//            obj.put("fission0", sumFission0);
//            obj.put("fission1", sumFission1);
//            obj.put("fission2", sumFission2);
//            jsonArray.add(obj);
//        }
//        System.out.println(jsonArray.toJSONString());
//    }
//
//    @Test
//    void ii() throws IOException {
//        String dateStr = "20240911";
//        List<AccountAvgInfo> accountAvgInfoList = accountAvgInfoRepository.getAllByStatusEquals(1);
//        Map<String, String> accountMap = accountAvgInfoList.stream().collect(
//                Collectors.toMap(AccountAvgInfo::getAccountName, AccountAvgInfo::getGhId, (existing, replacement) -> replacement));
//        BufferedReader reader = new BufferedReader(new FileReader("/Users/wangyunpeng/Downloads/账号相关性.json"));
//        StringBuilder sb = new StringBuilder();
//        String line;
//        while ((line = reader.readLine()) != null) {
//            sb.append(line);
//        }
//        String jsonStr = sb.toString();
//        // 使用 ObjectMapper 解析 JSON
//        ObjectMapper objectMapper = new ObjectMapper();
//
//        try {
//            // 将 JSON 转换为 Map<String, Map<String, Double>>
//            Map<String, Map<String, Double>> result = objectMapper.readValue(jsonStr,
//                    new TypeReference<Map<String, Map<String, Double>>>() {
//                    });
//
//            // 输出转换结果
//            System.out.println(result);
//            List<AccountCorrelation> saveList = new ArrayList<>();
//            result.forEach((k, v) -> {
//                String ghId = accountMap.get(k);
//                v.forEach((k1, v1) -> {
//                    String relGhId = accountMap.get(k1);
//                    AccountCorrelation save = new AccountCorrelation();
//                    save.setDateStr(dateStr);
//                    save.setGhId(ghId);
//                    save.setAccountName(k);
//                    save.setRelGhId(relGhId);
//                    save.setRelAccountName(k1);
//                    save.setStatus(1);
//                    save.setCorrelation(v1);
//                    saveList.add(save);
//                });
//            });
//            List<AccountCorrelation> all = new ArrayList<>(saveList);
//            for (AccountCorrelation item : all) {
//                if (!item.getGhId().equals(item.getRelGhId())) {
//                    AccountCorrelation save = new AccountCorrelation();
//                    BeanUtils.copyProperties(item, save);
//                    save.setGhId(item.getRelGhId());
//                    save.setAccountName(item.getRelAccountName());
//                    save.setRelGhId(item.getGhId());
//                    save.setRelAccountName(item.getAccountName());
//                    saveList.add(save);
//                }
//            }
//            crawlerBaseMapper.batchInsertAccountCorrelation(saveList);
//
//
//        } catch (IOException e) {
//            e.printStackTrace();
//        }
//    }

}
